/***************************************************************************
                          s_stacked_pair.cpp  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>

#include "constants.h"
#include "structs.h"
#include "externs.h"
#include "common.h"
#include "simfold.h"
#include "s_stacked_pair.h"



s_stacked_pair::s_stacked_pair (int *seq, int length)
// The constructor
{
    sequence = seq;     // just refer it from where it is in memory
    seqlen = length;
    this->V = NULL;
}



s_stacked_pair::~s_stacked_pair ()
// The destructor
{
}


int s_stacked_pair::compute_energy (int i, int j)
// compute the free energy of the structure closed by this stacked pair
{
    int min=INF, local_energy, V_energy;

    V_energy = V->get_energy (i+1,j-1);

    local_energy = stack[sequence[i]]
                            [sequence[j]]
                            [sequence[i+1]]
                            [sequence[j-1]];

    min = V_energy + local_energy;
    return min;
}


int s_stacked_pair::get_energy (int i, int j, int *sequence)
// returns the free energy of the stacked pair closed at (i,j)
{
    return stack [sequence[i]]
                     [sequence[j]]
                     [sequence[i+1]]
                     [sequence[j-1]];
}


int s_stacked_pair::get_enthalpy (int i, int j, int *sequence)
// returns the enthalpy of the stacked pair closed at (i,j)
{
  if (i+1 >= j-1) return INF;
        return enthalpy_stack [sequence[i]]
                              [sequence[j]]
                              [sequence[i+1]]
                              [sequence[j-1]];
}

